// KCtl.cpp : Implementation of the CKCtrl ActiveX Control class.

#include "stdafx.h"
#include "Afxtempl.h"	// template clist<>

#include "K.h"
#include "KCtl.h"
#include "KPpg.h"
#include "caseNB.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define hz 600
#define BUT 64

CcaseNB caseNB[65] ;

struct choix {
	int deltal;
	int deltac;
};

struct choix xy[8] = {
	{ -2, -1},
	{-2,1},
	{-1, -2},
	{-1, 2},
	{1, -2},
	{ 1,2},
	{2, -1},
	{2, 1}
};
IMPLEMENT_DYNCREATE(CKCtrl, COleControl)

#define WM_DISP_MESSAGE (WM_USER + 100)
#define WM_CLR_MYMESSAGE (WM_USER + 101)
#define WM_END_MYMESSAGE (WM_USER + 102)
/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CKCtrl, COleControl)
	//{{AFX_MSG_MAP(CKCtrl)
	ON_MESSAGE(WM_DISP_MESSAGE, DisplayCase)
	ON_MESSAGE(WM_CLR_MYMESSAGE, ClearCase)
	ON_MESSAGE(WM_END_MYMESSAGE, SignalEnd)
	ON_BN_CLICKED(IDC_D_BPROGRESS, OnBprogress)
	ON_BN_CLICKED(IDC_D_BRESET, resetFxn)
	ON_BN_CLICKED(IDC_D_BSTART, OnBstart)
	ON_BN_CLICKED(IDC_D_TRD, SetTrDisplay)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(EN_SETFOCUS, ID_EXTRA_EDIT, ID_EXTRA_EDIT+63, OnSetFocus)
	ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CKCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CKCtrl)
	DISP_PROPERTY_NOTIFY(CKCtrl, "TRDisplay", m_TRDprop, OnTRDisplayChanged, VT_I2)
	DISP_FUNCTION(CKCtrl, "go", go, VT_EMPTY, VTS_I2)
	DISP_STOCKPROP_BACKCOLOR()
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CKCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CKCtrl, COleControl)
	//{{AFX_EVENT_MAP(CKCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CKCtrl, 2)
	PROPPAGEID(CKPropPage::guid)
	PROPPAGEID(CLSID_CColorPropPage)
END_PROPPAGEIDS(CKCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CKCtrl, "K.KCtrl.1",
	0xac865686, 0xd735, 0x11d3, 0x94, 0xa2, 0xd5, 0x50, 0x21, 0x7b, 0xd1, 0x43)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CKCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DK =
		{ 0xac865684, 0xd735, 0x11d3, { 0x94, 0xa2, 0xd5, 0x50, 0x21, 0x7b, 0xd1, 0x43 } };
const IID BASED_CODE IID_DKEvents =
		{ 0xac865685, 0xd735, 0x11d3, { 0x94, 0xa2, 0xd5, 0x50, 0x21, 0x7b, 0xd1, 0x43 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwKOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CKCtrl, IDS_K, _dwKOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CKCtrl::CKCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CKCtrl

BOOL CKCtrl::CKCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegInsertable | afxRegApartmentThreading to afxRegInsertable.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_K,
			IDB_K,
			afxRegInsertable | afxRegApartmentThreading,
			_dwKOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CKCtrl::CKCtrl - Constructor

CKCtrl::CKCtrl()
{
	InitializeIIDs(&IID_DK, &IID_DKEvents);
	int j,y;
	COLORREF x;

	// TODO: Initialize your control's instance data here.

	m_start = 1;
	m_TRdisplay = 1;
	m_init = true;
	m_ShowDegrade = false;
	m_delai = 1000;
	m_encours = false;

	
	/*
	INIT de la table de dgrad
	*/

	for (j = 1;j<= 64; j++) {
		if (j > 42) {
			y = 255 - 20 * (j - 43);
			if (y < 0) {
				y = 0;
			}
			x = RGB(45 + (10) * (j - 43), 0, y);
		}
		else if ((j <= 42) && (j > 21)) {
			y = 255 - 20 * (j - 21);
			if (y < 0) {
				y = 0;
			}
			x = RGB(0, y, 45 + (10) * (j - 21));
		}
		else if (j <= 21) {
			x = RGB(0, 45 + 10 * (j), 0);
		}
		m_degrade[j-1] = x;
		m_brush[j-1] = ::CreateSolidBrush(x);
}

	/*
	Init des variables
	*/
	initp(0);
}


/////////////////////////////////////////////////////////////////////////////
// CKCtrl::~CKCtrl - Destructor

CKCtrl::~CKCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CKCtrl::OnDraw - Drawing function

void CKCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	CString Cst; 
	CBrush bkBrush;
	bkBrush.CreateSolidBrush(TranslateColor(GetBackColor()));
    pdc->FillRect( rcBounds, &bkBrush );
   	
	if (m_init) {
		m_init = false;
		InitDisplay(pdc, rcBounds, rcInvalid);
	}
	switch (m_state) {
	case 1 :
		CurrentStateDisplay(); // affiche les 64 cases sans couleur
		break;
	case 2:
		ResetDisplay();			// efface toutes les case
		break;
	default:
		AfxMessageBox("What");
		;
	}
}


/////////////////////////////////////////////////////////////////////////////
// CKCtrl::DoPropExchange - Persistence support

void CKCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CKCtrl::OnResetState - Reset control to default state

void CKCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CKCtrl::AboutBox - Display an "About" box to the user

void CKCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_K);
	dlgAbout.DoModal();
}


/*

  Dans un thread a part
*/

UINT lance( LPVOID  start )
{
int x,y,orig;

x = *(int *)start;
y=0;

	while (caseNB[x].Index < BUT) {
		if (true == caseNB[x].CanIStep(y)) {
			orig = x;
			x = caseNB[x].destination;
			caseNB[x].Step (orig);
			y = 0;
		} else {
			caseNB[x].clear_affiche();
			caseNB[x].free = true;
			x = caseNB[x].origine;
			while (caseNB[x].blocage())
				x = caseNB[x].origine;
			y = caseNB[x].contrainte + 1;
		}
	}
	caseNB[0].SignalEnd();
	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CKCtrl message handlers
void CKCtrl::OnBstart() 
{
	// TODO: Add your control notification handler code here
int i;
int _start; 

	if (!m_encours) {  
		m_encours = true;
		if (m_delai == 1000) {   // on ne trace pas le chemin
			for(i=0;i<64;i++) {
				if (caseNB[i].free == false) {
					_start = i;
					break;
				}
			}
			initp(1);	// remet tout a zero (d'ou la boucle prcedente)
						// qui mmorise la case de dpart

			m_state =1;
			m_start = _start;
			m_ShowDegrade = false;

			caseNB[m_start].origine = -1;
			caseNB[m_start].contrainte = 0;
			caseNB[m_start].Index = 1;
			caseNB[m_start].free = false;

			AfxBeginThread(lance,&(this->m_start));
		}
	}
}





void CKCtrl::initp(int init1) // non utilis
{
CString  strTmp;
CFont* pFont = new(CFont);;
LOGFONT* lpLogFont = new (LOGFONT);;

int col, lin;
int k ,j ,cible, i ;
CList<int, int> tmp_list(9);
POSITION pos,pos_sav;
int x,y,z,maxi;

		 //options d'affichage

	lpLogFont-> lfHeight = 24; 
	lpLogFont-> lfWidth = 0; 
	lpLogFont-> lfEscapement = 0; 
	lpLogFont-> lfOrientation = 0; 
	lpLogFont-> lfWeight = FW_BLACK; 
	lpLogFont-> lfItalic = 0; 
	lpLogFont-> lfUnderline  = 0; 
	lpLogFont-> lfStrikeOut = 0; 
	lpLogFont-> lfCharSet = ANSI_CHARSET; 
	lpLogFont-> lfOutPrecision = OUT_DEFAULT_PRECIS; 
	lpLogFont-> lfClipPrecision = CLIP_DEFAULT_PRECIS; 
	lpLogFont-> lfQuality = PROOF_QUALITY; 
	lpLogFont-> lfPitchAndFamily = VARIABLE_PITCH | FF_ROMAN; 
	strcpy(lpLogFont-> lfFaceName,"Times New Roman"); 

	pFont->CreateFontIndirect(lpLogFont);

	for (i = 0;i<= 64;i++) {
		col = i % 8;
		lin = (i - col) / 8;
		caseNB[i].colonne = col;
		caseNB[i].ligne = lin;
		caseNB[i].current = i;
		caseNB[i].free = true;
		caseNB[i].Index = -77;
		caseNB[i].contrainte = 0;
		caseNB[i].nborigine = 0;
		caseNB[i].m_linkWnd = this;
		k = 0;
		for (j = 0 ;j<=7;j++) {
			cible = 8 * (lin + xy[j].deltal) + 
 				col + xy[j].deltac;

			if ((lin + xy[j].deltal <= 7) && 
 				(lin + xy[j].deltal >= 0) && 
 				(col + xy[j].deltac <= 7) &&
 				(col + xy[j].deltac >= 0) ) {
 					caseNB[i].possibilites[k] = cible;
 					k = k + 1;
 			}
		}
		caseNB[i].possibilites[k] = -1;
	}
 
 /*
 ' rorganisation des destinations possibles
 ' tries par ordre de nombre origines possibles croissantes
 ' => on favorise les case excentres
 */
 
	caseNB[64].nborigine = 9 ; // Pour l'algo de rorg.
 
 /*
 ' init du nombre d'origines possibles / case
 */
	for (i = 0;i<=63;i++)  {
		k = 0;
		while (caseNB[i].possibilites[k] != -1) {
			caseNB[caseNB[i].possibilites[k]].nborigine = 
					caseNB[caseNB[i].possibilites[k]].nborigine + 1;
			k = k + 1;
		}
	}
 
 //favoriser les cases excentres

	for (i = 0;i<= 63;i++) {
 		k = 0;
 		maxi = 64 ;  // une case fictive  9 origines !!
		/*
		Constitution d'une liste de destinations tries
		par nb origines croissantes
		*/
 		tmp_list.AddHead(maxi);
 		while (caseNB[i].possibilites[k] != -1) {
 			x = caseNB[i].possibilites[k];
 			y = caseNB[x].nborigine;
 			pos = tmp_list.GetHeadPosition( ); 
 			while (1) {
 				pos_sav = pos;
 				z = tmp_list.GetNext(pos);
 				if (y <= caseNB[z].nborigine) {
 					tmp_list.InsertBefore(pos_sav,x);
 					break;
 				}
 			}
 			k = k + 1;
 		}
		 /*
 			Copie dans le bon ordre (nb origines croissantes) 
 			dans la liste
		 */
 		pos = tmp_list.GetHeadPosition();
 		k = 0;
 		do {
 			z = tmp_list.GetNext(pos);
 			if (z == 64) {
 				z = -1;
 			}
 			caseNB[i].possibilites[k] = z;
 			k = k + 1;
 		} while (z != -1);
 		tmp_list.RemoveAll();
	}
	m_state = 1;
}

UINT dessin_echiquier(LPVOID timer)
{                           
int i,j ;
CString Cst;
int T=*(int *)timer;

	caseNB[0].m_linkWnd->m_delai = 999; // Le thread tourne 
										// CKctrl le sait
// affichage final dans l'ordre du dplacement
	for (j = 1;j<= 64; j++) {  // chemin = suite d'index de dplacement
		for (i = 0;i<= 63;i++) { // recherche de la case 
			if ((caseNB[i].free == false) && (caseNB[i].Index == j)) 
				caseNB[i].affiche(true);
		}
		Sleep(caseNB[i].m_linkWnd->m_delai);
	}
	caseNB[i].m_linkWnd->m_delai = 1000; // le dlai standard 
	return 0;
}

void CKCtrl::OnBprogress() 
{
static CWinThread* CWT=0;
	// TODO: Add your control notification handler code here
int i;
	
	// Pour tracer la progression le chemin doit tre trouve
	// => Toutes les cases sont occupes

	for (i=0;i<64;i++)
		if (caseNB[i].free == true)
			return;

	// On lance le trac que si ce n'est pas dj fait
		
	if (m_delai == 1000) {
		ResetDisplay();
		m_ShowDegrade = true;
		CWT = AfxBeginThread(dessin_echiquier,&(this->m_delai));	
	} else	{				// la progression tourne
		switch (m_delai) {	// on accelre  chaque click...
		case 999 :
			m_delai = 500;
			break;
		case 500 :
			m_delai = 250;
			break;
		case 250 :
			m_delai = 100;
			break;
		case 100 :
			m_delai = 50;
			break;
		case 50 :
			m_delai = 1;
			break;
		default :
			;
		}
	}
}

void CKCtrl::resetFxn() 
{
int i;
	// TODO: Add your specialized code here and/or call the base class

	// TODO: Add your message handler code here
		if (m_delai == 1000) { // on ne trace pas le chemin
			for (i=0;i<64;i++)
				if (caseNB[i].free == true) {
					AfxMessageBox("Attendez,recherche en cours ...");
					return;
				}

			m_state = 2;
			m_ShowDegrade = false;
			InvalidateControl(NULL);
			ResetDisplay();
		}
}


void CKCtrl::ResetDisplay()
{
CString Cst;
int i,j;

	m_ShowDegrade = false;
	for (i=0;i<8;i++) 
	{
		for (j=0;j<8;j++) 
		{
			Cst.Format("");
			m_editc[i+8*j].SetWindowText(Cst);
			m_editc[i+8*j].RedrawWindow();
		}
	}
}



void CKCtrl::InitDisplay(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	//pdc->Ellipse(rcBounds);

	CButton *CBstart = new CButton;
	CButton *CBreset = new CButton;
	CButton *CBprogress =new CButton;
	CButton *CTrDisplay = new CButton;
	CRect recSTART(280,5,370,55),recRESET(280,75,370,125),recPROGRESS(280,145,370,195);
	CRect recTRD(280,215,390,265);
	// TODO: Add your specialized code here and/or call the base class
	int i,j;
	CString Cst; 
	//
	// chiquier
	//
	
	for (i=0;i<8;i++) 
	{
		for (j=0;j<8;j++) 
		{
			if (m_editc[i+8*j].m_hWnd == NULL)
			{
				m_start = 0;
		//
		// Chaque CEditCase connat sa position (initialise ici)
		// C'est aussi l'index de l'identifiant de ressource
		//
				m_editc[i+8*j].m_numero = i+8*j;
				CRect rect(5+30*i-min(1,i), 215-30*j, 35+30*i, 245-30*j+min(1,j));
				m_editc[i+8*j].Create(WS_CHILD | WS_VISIBLE | ES_CENTER |
			ES_NOHIDESEL | ES_AUTOHSCROLL | WS_BORDER, rect, this, ID_EXTRA_EDIT+i+8*j);
					
			}
		}
	}
	//
	// Les boutons commandes
	//
	CBstart->Create("START",WS_CHILD | WS_VISIBLE | WS_TABSTOP |
					BS_PUSHBUTTON | WS_BORDER, recSTART, this, IDC_D_BSTART);

	CBreset->Create("RESET",WS_CHILD | WS_VISIBLE | WS_TABSTOP |
					BS_PUSHBUTTON | WS_BORDER, recRESET, this, IDC_D_BRESET);

	CBprogress->Create("PROGRESS",WS_CHILD | WS_VISIBLE | WS_TABSTOP |
					BS_PUSHBUTTON | WS_BORDER, recPROGRESS, this, IDC_D_BPROGRESS);

	CTrDisplay->Create("TR Display",WS_CHILD | WS_BORDER| WS_VISIBLE | BS_CHECKBOX       
				, recTRD, this,IDC_D_TRD);
	CTrDisplay->SetCheck(m_TRdisplay); // Cause un PB quand le Control est insr dans Winword
}



void CKCtrl::CurrentStateDisplay()
{
	CString Cst ;
	CString Cst0 = "";
	int i;
	
	for(i=0;i<64;i++) {
		if (caseNB[i].free == false) {
			Cst.Format("%d",caseNB[i].Index);
			m_editc[i].SetWindowText(Cst);
		}
	} 
}


void CKCtrl::SetTrDisplay()
{
	CButton  *  l_pWnd  ;
	
	l_pWnd = (CButton *)GetDlgItem(IDC_D_TRD );
	ASSERT ( l_pWnd );
	
	if (m_TRdisplay == 1)
		m_TRdisplay = 0;
	else
		m_TRdisplay =1;

	l_pWnd->SetCheck(m_TRdisplay);
}



void CKCtrl::go(short depart) 
{
	// TODO: Add your dispatch handler code here
	m_ShowDegrade = false;
	initp(1);	// remet tout a zero 
	m_state =1;
	m_start = depart;
	caseNB[m_start].Index = 1;
	caseNB[m_start].affiche(false);
	
	caseNB[m_start].origine = -1;
	caseNB[m_start].contrainte = 0;
	caseNB[m_start].Index = 1;
	caseNB[m_start].free = false;

	AfxBeginThread(lance,&(this->m_start));

}



void CKCtrl::OnTRDisplayChanged() 
{
	// TODO: Add notification handler code

	CButton  *  l_pWnd  ;
	
	l_pWnd = (CButton *)GetDlgItem(IDC_D_TRD );
	ASSERT ( l_pWnd );
	
	m_TRdisplay = (m_TRDprop?1:0);
	l_pWnd->SetCheck(m_TRdisplay);
	SetModifiedFlag();
}


void CKCtrl::OnSetFocus(UINT nID ) 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
	
	CWnd  *  l_pWnd;
	CString  strTmp;
	
	if (!m_encours) {
		m_start = nID - ID_EXTRA_EDIT;
		l_pWnd = GetDlgItem ( nID );
		ASSERT ( l_pWnd );

		ResetDisplay();
		
		strTmp.Format ("1");
		l_pWnd->SetWindowText ( strTmp );
	}
}

HBRUSH CKCtrl::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
CString Cst;
int i,j;
if (nCtlColor == CTLCOLOR_EDIT) {
	if (m_ShowDegrade == true) {
		for (i=0;i<=63;i++) {
			if( pWnd->GetSafeHwnd() == 
				GetDlgItem(ID_EXTRA_EDIT+i)->GetSafeHwnd() )
			{
				j = caseNB[i].Index;
				HBRUSH hbr = m_brush[j-1]; // C'est la brush 
				pDC->SetTextColor( RGB(255,255,255) );
				pDC->SetBkColor( m_degrade[j-1] );
				return hbr;
			}
		}
	}
}
return COleControl::OnCtlColor(pDC, pWnd, nCtlColor);
}

/*
	Reception du message WM_DISP_MESSAGE
*/

LRESULT CKCtrl::DisplayCase(WPARAM WParam, LPARAM LParam)
{
	CWnd  *  l_pWnd  ;
	CString Cst;

	l_pWnd = this->GetDlgItem(ID_EXTRA_EDIT + WParam );
	Cst.Format("%d",LParam);
	l_pWnd->SetWindowText(Cst);
	l_pWnd->RedrawWindow();
	return (LRESULT)0;
}

/*
	Reception du message WM_CLR_MESSAGE
*/


LRESULT CKCtrl::ClearCase(WPARAM WParam, LPARAM LParam)
{
	CWnd  *  l_pWnd  ;
	
	l_pWnd = this->GetDlgItem(ID_EXTRA_EDIT + WParam );
	ASSERT ( l_pWnd );
	l_pWnd->SetWindowText("");
	l_pWnd->RedrawWindow();
	return (LRESULT)0;
}


LRESULT CKCtrl::SignalEnd(WPARAM WParam, LPARAM LParam)
{
	this->InvalidateControl();
	m_encours = false;
	return (LRESULT)0;
}


