#if !defined(AFX_KCTL_H__AC865694_D735_11D3_94A2_D550217BD143__INCLUDED_)
#define AFX_KCTL_H__AC865694_D735_11D3_94A2_D550217BD143__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EditCase2.h"

// KCtl.h : Declaration of the CKCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CKCtrl : See KCtl.cpp for implementation.

class CKCtrl : public COleControl
{
	DECLARE_DYNCREATE(CKCtrl)

// Constructor
public:
	CKCtrl();
	void SetTrDisplay();
	short m_TRdisplay;
	void CurrentStateDisplay();
	void InitDisplay(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	void ResetDisplay();
	void OnBstart();
	void OnSetFocus(UINT nID ) ;
	bool m_init;;
	int m_state;
	int m_start;
	CEditCase2 m_editc[64];
	void initp(int x);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CKCtrl();

	DECLARE_OLECREATE_EX(CKCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CKCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CKCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CKCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CKCtrl)
	
    afx_msg LRESULT DisplayCase(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT ClearCase(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT SignalEnd(WPARAM wParam, LPARAM lParam);
	afx_msg void OnBprogress();
	afx_msg void resetFxn();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CKCtrl)
	short m_TRDprop;
	afx_msg void OnTRDisplayChanged();
	afx_msg void go(short depart);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CKCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	bool m_encours;
	int m_delai;
	COLORREF m_degrade[64];
	bool m_ShowDegrade;
	HBRUSH m_brush[64];
	enum {
	//{{AFX_DISP_ID(CKCtrl)
	dispidTRDisplay = 1L,
	dispidGo = 2L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KCTL_H__AC865694_D735_11D3_94A2_D550217BD143__INCLUDED)
