// caseNB.cpp: implementation of the CcaseNB class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Resource.h"
#include "caseNB.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern CcaseNB caseNB[];

#define WM_DISP_MESSAGE (WM_USER + 100)
#define WM_CLR_MESSAGE (WM_USER + 101)
#define WM_END_MESSAGE (WM_USER + 102)


// la case reoit un ordre d'avance => retour True
// on peut avancer

bool CcaseNB::CanIStep(int tent)
{
int  k ;

	k = tent;
	while (caseNB[current].possibilites[k] != -1 ) {
		if (caseNB[caseNB[current].possibilites[k]].free == true ) {

		 /*La case "current" ne peut plus servir d'origine
		 ' vrification des origines disponibles sur les cases
		 ' restantes
		 */
			destination = caseNB[current].possibilites[k];
		 /*
		 ' case "destination" mise  occupe par anticipation
		 */
 			caseNB[destination].setbusy();
			if (impasse(current) == false) {
				contrainte = k;
				return true;
			}
			else {
				caseNB[destination].setfree();
			}
		}
		k=k+1;
	}
	return false;
}


bool CcaseNB::blocage() 
{

int i ;

	i = 0;
	while (caseNB[current].possibilites[i] != -1) {
		caseNB[caseNB[current].possibilites[i]].nborigine = 
			caseNB[caseNB[current].possibilites[i]].nborigine + 1;
		i = i + 1;
	}

	if (caseNB[current].possibilites[contrainte + 1] == -1) {
		clear_affiche();
		free = true;
		return true;
	/*
	' remise  niveau de nborigine (dest non retenue)
	*/
	}
	return false;
}

void CcaseNB::Step(int from)
{
/*
' free est dj  false
*/
int ind;

ind = caseNB[from].Index;
origine = from;
Index = ind + 1;
if (m_linkWnd->m_TRdisplay)
	affiche(false);
}

void CcaseNB::setbusy()
{
	free = false;
}

void CcaseNB::setfree()
{
	free = true;
}

bool CcaseNB::impasse(int mycase) 
{
bool imp;
int k,i;
	imp = false;

	// modif des nborigines
	// on supprime des nborigines les destinations de mycase

	k = 0;
	while (caseNB[mycase].possibilites[k] != -1) {
		caseNB[caseNB[mycase].possibilites[k]].nborigine = 
			caseNB[caseNB[mycase].possibilites[k]].nborigine - 1;
		k = k + 1;
	}
	/*
	' test des solutions restantes
	*/
	for (i = 0;i<= 63;i++) { 
		if ((caseNB[i].free == true) && (caseNB[i].nborigine == 0)) {
			imp = true;
	/*
	' remise  niveau de nborigine (dest non retenu)
	*/
			k = 0;
			while (caseNB[mycase].possibilites[k] != -1) {
				caseNB[caseNB[mycase].possibilites[k]].nborigine =  
					caseNB[caseNB[mycase].possibilites[k]].nborigine + 1;
				k = k + 1;
			}
			break;
		}
	}
	return imp;
}



CcaseNB::CcaseNB()
{

}

CcaseNB::~CcaseNB()
{

}
void CcaseNB::affiche(bool x)
{	
	ASSERT ( m_linkWnd );
	if ((caseNB[0].m_linkWnd->m_TRdisplay) || (x))
		m_linkWnd->SendMessage(WM_DISP_MESSAGE,(WPARAM) current,(LPARAM)Index);

}

void CcaseNB::clear_affiche()
{
	ASSERT ( m_linkWnd );
	if (caseNB[0].m_linkWnd->m_TRdisplay)
		m_linkWnd->SendMessage(WM_CLR_MESSAGE,(WPARAM) current);

}

void CcaseNB::SignalEnd()
{
	ASSERT ( m_linkWnd );
	m_linkWnd->SendMessage(WM_END_MESSAGE);

}
